﻿© 2008 Fluke Corporation, All rights reserved               MET/CAL Procedure
=============================================================================
INSTRUMENT:            Sub Parse Identification Query (*IDN?) Response
DATE:                  2008-12-12 10:08:53
AUTHOR:                Fluke
REVISION:              $Revision: 2619 $
ADJUSTMENT THRESHOLD:  70%
NUMBER OF TESTS:       1
NUMBER OF LINES:       114
=============================================================================
#
#  Procedure Author:   DAC, DFM
#
#  Models covered:     All IEEE-488.2 compatible UUTs
#
#  Compatibility:      MET/CAL 7.01 SP2 or later
#
#  Subprocedures:      None
#
#  Required Files:     None
#
#  Required Equipment: None
#
#  The copyright in this procedure is owned by Fluke Corporation.
#
# String Registers:
#   S[1] = Manufacturer
#   S[2] = Model
#   S[3] = Serial Number or "Not available" if S[3] is "0" (see IEEE-488.2)
#   S[4] = Firmware Level or "Not available" if S[4] is "0" (see IEEE-488.2)
#
# VARIABLE.DAT Entries:
#   Manufacturer$ = S[1]
#   Model_Num$    = S[2]
#   Serial_Num$   = S[3]
#   Firmware_Rev$ = S[4]
#
#   Note, if S[2], S[3], or S[4] contains a leading space, it is stripped
#   off before writing the string to VARIABLE.DAT.
#
 STEP    FSC    RANGE NOMINAL        TOLERANCE     MOD1        MOD2  3  4 CON

  1.001  MATH         S[1] = FLD(MEM2, 1, ",")
  1.002  MATH         S[2] = FLD(MEM2, 2, ",")
  1.003  MATH         S[3] = FLD(MEM2, 3, ",")
  1.004  MATH         S[4] = FLD(MEM2, 4, ",")

# Some manufacturers pad the fields with a space.
#
# Ex. "Hewlett-Packard, E4401B, US39120213, A.06.00"
#
# Strip leading whitespace from fields.

# Check model field for leading whitespace.
  1.005  IF           ZCMP(SUB(S[2], 1, 1), " ")
  1.006  MATH         S[2] = SUB(S[2], 2, LEN(S[2]))
  1.007  ENDIF

# IEEE-488.2 allows manufacturers to return "0" in the serial number and
# firmware revision fields if the actual serial number and/or firmware
# revision is not available for the *IDN? response string.

# Check serial number field for "0" or leading whitespace.
  1.008  IF           ZCMP(S[3], "0") || ZCMP(S[3], " 0")
  1.009  MATH         S[3] = "Not available"
  1.010  ELSEIF       ZCMP(SUB(S[3], 1, 1), " ")
  1.011  MATH         S[3] = SUB(S[3], 2, LEN(S[3]))
  1.012  ENDIF

# Check firmware revision field for "0" or leading whitespace.
  1.013  IF           ZCMP(S[4], "0") || ZCMP(S[4], " 0")
  1.014  MATH         S[4] = "Not available"
  1.015  ELSEIF       ZCMP(SUB(S[4], 1, 1), " ")
  1.016  MATH         S[4] = SUB(S[4], 2, LEN(S[4]))
  1.017  ENDIF

# Make sure firmware level string is not too big for DISP statement line.
  1.018  MATH         L[1] = 56 - LEN("Firmware Level:") - 2

  1.019  IF           LEN(S[4]) > L[1]
  1.020  MATH         S[5] = SUB(S[4], 1, L[1])
  1.021  MATH         S[6] = SUB(S[4], (L[1] + 1), LEN(S[4]))
  1.022  DISP         Manufacturer:    [SREG1]
  1.022  DISP         Model:           [SREG2]
  1.022  DISP         Serial Number:   [SREG3]
  1.022  DISP         Firmware Level:  [SREG5]
  1.022  DISP         [32]                [SREG6]
# Write serial number and firmware revision to results file.
  1.023  RSLT         =
  1.024  RSLT         = Serial Number:   [SREG3]
  1.025  RSLT         = Firmware Level:  [SREG5]
  1.026  RSLT         =[32]                 [SREG6]
  1.027  ELSE
  1.028  DISP         Manufacturer:    [SREG1]
  1.028  DISP         Model:           [SREG2]
  1.028  DISP         Serial Number:   [SREG3]
  1.028  DISP         Firmware Level:  [SREG4]
# Write serial number and firmware revision to results file.
  1.029  RSLT         =
  1.030  RSLT         = Serial Number:   [SREG3]
  1.031  RSLT         = Firmware Level:  [SREG4]
  1.032  ENDIF

# Update VARIABLE.DAT.
  1.033  MATH         MEM2 = PUTV("Manufacturer", S[1])
  1.034  MATH         MEM2 = PUTV("Model_Num",    S[2])
  1.035  MATH         MEM2 = PUTV("Serial_Num",   S[3])
  1.036  MATH         MEM2 = PUTV("Firmware_Rev", S[4])

  1.037  END
